



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>为什么现在我最终推荐内存OLTP</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">为什么现在我最终推荐内存OLTP</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-10 20:04:39 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在今年的8月份，我写了篇文章，介绍了<a href="http://www.cnblogs.com/woodytu/p/4718352.html" rel="external nofollow noreferrer">我还不推荐用户使用内存OLTP的各个理由</a>。近日很多人告诉我，他们有一些性能的问题，并考虑使用内存OLTP来解决它们。</p>
<p>众所皆知，在SQL Server里内存OLTP是个非常特别的技术，在很多情况下并不适用，但这是在SQL Server 2014里的首次实现，它有很多限制，我在<a href="http://www.cnblogs.com/woodytu/p/4718352.html" rel="external nofollow noreferrer">这篇文章里已经介绍</a>。</p>
<p>感谢上帝&mdash;&mdash;现在事情已经改变了！几个星期前，SQL Server 2016的CTP 3版本已经可以公开下载了。在内存OLTP领域，微软做出了巨大的改进。我们来详细看下。</p>
<p>首先我们创建测试的数据库：</p>
<div>
<pre class="prettyprint linenums">USE master<br />
GO

-- Create new database<br />
CREATE DATABASE InMemoryOLTP<br />
GO

--Add MEMORY_OPTIMIZED_DATA filegroup to the database.<br />
ALTER DATABASE InMemoryOLTP<br />
ADD FILEGROUP InMemoryOLTPFileGroup CONTAINS MEMORY_OPTIMIZED_DATA<br />
GO

USE InMemoryOLTP<br />
GO

-- Add a new file to the previous created file group<br />
ALTER DATABASE InMemoryOLTP ADD FILE<br />
(<br />
    NAME = N'InMemoryOLTPContainer',<br />
    FILENAME = N'C:\Program Files\Microsoft SQL Server\MSSQL13.MSSQLSERVER\MSSQL\DATA\InMemoryOLTPContainer'<br />
)<br />
TO FILEGROUP [InMemoryOLTPFileGroup]<br />
GO</pre>
</div>
<h1>外键约束(Foreign-Key Constraints)</h1>
<p>一个最重要的改变，或者我应该说是提升&mdash;&mdash;是支持外键约束！是的，你没有听错：内存OLTP现在支持外键约束。在最初的实现里通常你会期望是支持外键约束，因为这是涉及OLTP情景，但在SQL Server 2014上微软并不支持。我们来看下面的代码：</p>
<div>
<pre class="prettyprint linenums"> -- Create a parent table<br />
 CREATE TABLE Parent<br />
 (<br />
     ParentID INT IDENTITY(1, 1) NOT NULL,<br />
     Col1 CHAR(100) NOT NULL,<br />
     Col2 CHAR(100) NOT NULL,<br />
     Col3 CHAR(100) NOT NULL,<br />
     CONSTRAINT chk_PrimaryKey_Parent PRIMARY KEY NONCLUSTERED HASH (ParentID) WITH (BUCKET_COUNT = 1024)<br />
 )<br />
 WITH (MEMORY_OPTIMIZED = ON)<br />
 GO

 -- Create a child table<br />
 CREATE TABLE Child<br />
 (<br />
     ChildID INT IDENTITY(1, 1) NOT NULL,<br />
     ParentID INT NOT NULL,<br />
     Col1 CHAR(100) NOT NULL,<br />
     Col2 CHAR(100) NOT NULL,<br />
     Col3 CHAR(100) NOT NULL,

     -- Create a FK constraint between both tables<br />
     CONSTRAINT FK_Child_Parent FOREIGN KEY (ParentID)<br />
     REFERENCES Parent (ParentID),

     CONSTRAINT chk_PrimaryKey_Child PRIMARY KEY NONCLUSTERED HASH (ChildID) WITH (BUCKET_COUNT = 1024)<br />
 )<br />
 WITH (MEMORY_OPTIMIZED = ON)<br />
 GO

 -- Insert some records into both tables<br />
 INSERT INTO Parent VALUES ('a', 'a', 'a'), ('b', 'b', 'b'), ('c', 'c', 'c')<br />
 INSERT INTO Child VALUES (1, 'a', 'a', 'a'), (1, 'b', 'b', 'b'), (1, 'c', 'c', 'c')<br />
 GO</pre>
</div>
<p>这段代码在2个表（parent和child表）之间创建了一个简单的外键约束。另外我也在2个表里也插入了些测试数据。现在我们对这2个表进行简单的查询：</p>
<div>
<pre class="prettyprint linenums"> -- The unnecessary join is removed in the execution plan.<br />
 SELECT c.* FROM Parent p<br />
 JOIN Child c ON c.ParentID = p.ParentID<br />
 GO</pre>
</div>
<p>当你看查询本身时，你会看见我只想返回child表的内容。基于外键约束，查询优化器知道在parent表里肯定有记录存在。因此查询优化器通过移除不需要的表连接来简化查询。当你看执行计划时，你会看到这个简化真的发生了&mdash;&mdash;非常棒：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/750348/201511/750348-20151129144704188-1942242801.png" /></p>
<p>在SQL Server的内存OLTP里，这是其中一个最大的改进&mdash;&mdash;支持外键约束。对于外键约束的支持同样支持本地编译的存储过程，如下代码所示：</p>
<div>
<pre class="prettyprint linenums"> -- Create a natively compiled Stored Procedure<br />
 CREATE PROCEDURE InMemoryOLTPProcedure<br />
 WITH NATIVE_COMPILATION, SCHEMABINDING, EXECUTE AS OWNER<br />
 AS<br />
 BEGIN<br />
    ATOMIC WITH<br />
    (<br />
       TRANSACTION ISOLATION LEVEL = SNAPSHOT, LANGUAGE = 'us_english'<br />
    )

    SELECT c.ChildID, c.ParentID, c.Col1, c.Col2, c.Col3 FROM dbo.Parent p<br />
    JOIN dbo.Child c ON c.ParentID = p.ParentID<br />
 END<br />
 GO</pre>
</div>
<p>当你执行本地编译存储过程时，同样你没有可用的实际执行计划。你能查看的只有估计执行计划&hellip;&hellip;</p>
<h1>检查约束（Check Constraints）</h1>
<p>另外非常棒的提升是现在我们支持检查约束。检查约束非常重要，因为它告诉查询优化器你数据长相的更多信息。基于这些信息，查询优化器可以给你更好性能的执行计划。下面这段代码给你展示了一个使用内存OLTP如何定义检查约束的简单例子。</p>
<div>
<pre class="prettyprint linenums"> -- You can't create a CHECK constraint on a Memory Optimized Table<br />
 CREATE TABLE CheckConstraint<br />
 (<br />
     ID INT IDENTITY(1, 1) PRIMARY KEY NONCLUSTERED HASH WITH (BUCKET_COUNT = 1024),<br />
     Value INT NOT NULL DEFAULT 1 CONSTRAINT ck_Value CHECK (Value = 1)<br />
 )<br />
 WITH<br />
 (<br />
     MEMORY_OPTIMIZED = ON,<br />
     DURABILITY = SCHEMA_AND_DATA<br />
 )<br />
 GO</pre>
</div>
<p>从这个表定义你可以看到，这里我创建了一个简单的检查约束，告诉SQL Server在列值里只保存1的值。甚至否定检查在与约束检查组合也是支持的。下面这个查询会导致在执行计划里有常数扫描运算符。</p>
<div>
<pre class="prettyprint linenums"> -- Contradiction detection works with In-Memory OLTP.<br />
 SELECT * FROM CheckConstraint<br />
 WHERE Value = 0<br />
 GO</pre>
</div>
<h1>在字符列上的索引</h1>
<p>回到使用SQL Server 2014的旧时光里，内存OLTP里不支持字符列上的索引，因为你必须使用BIN2排序。对于大多数人来说这是个项目障碍，因为当你在字符列上进行比较或排序时，使用另一个排序会影响结果。</p>
<p>使用SQL Server 2016，微软现在已经最终移除了这个限制，现在你可以在字符列上直接创建哈希或范围索引，不需要使用BIN2排序。我们来看下面的例子，在SQL Server 2016里现在是正常运行的。</p>
<div>
<pre class="prettyprint linenums"> -- Creates a table with an index on a character column.<br />
 -- This works now without any problems in SQL Server 2016.<br />
 CREATE TABLE TestTable1<br />
 (<br />
     Col1 CHAR(10) NOT NULL PRIMARY KEY NONCLUSTERED HASH WITH (BUCKET_COUNT = 1024),<br />
     Col2 VARCHAR(100) NOT NULL,<br />
     Col3 VARCHAR(100) NOT NULL<br />
 ) WITH<br />
 (<br />
     MEMORY_OPTIMIZED = ON,<br />
     DURABILITY = SCHEMA_AND_DATA<br />
 )<br />
 GO</pre>
</div>
<p>非常炫&mdash;&mdash;太棒了！</p>
<h1>架构和桶数改变</h1>
<p>在SQL Server 2014里这个真的是很糟也很烂：在内存优化表上架构修改是不完全不支持的。你需要删掉并重建你的表，即使你只想增加一个索引或修改现存的索引。抱歉，这是我绝不推荐用户使用内存OLTP的一个最主要原因。即使对于哈希索引修改桶数，你也要删除并重建你的表。</p>
<p>使用SQL Server 2016，生活现在好多了，一切变得简单了。首先你可以使用简单的ALTER INDEX REBUILD语句来修改现存索引的桶数。要留意的是你需要有表大小的2倍内存。下列代码显示这个提升：</p>
<div>
<pre class="prettyprint linenums"> -- We can change now the bucket count without dropping the table<br />
 ALTER TABLE Parent<br />
 ALTER INDEX chk_PrimaryKey_Parent<br />
 REBUILD WITH (BUCKET_COUNT = 1048576)<br />
 GO</pre>
</div>
<p>另外在你创建内存优化表后，现在你可以修改你的表，甚至创建索引。我还没尝试所有的可能修改，但下面的代码可以给你一个你期望SQL Server 2016的一个大致想法。</p>
<div>
<pre class="prettyprint linenums"> -- Creates a table with an index on a character column.<br />
 -- This works now without any problems in SQL Server 2016.<br />
 CREATE TABLE TestTable1<br />
 (<br />
     Col1 CHAR(10) NOT NULL PRIMARY KEY NONCLUSTERED HASH WITH (BUCKET_COUNT = 1024),<br />
     Col2 VARCHAR(100) NOT NULL,<br />
     Col3 VARCHAR(100) NOT NULL<br />
 ) WITH<br />
 (<br />
     MEMORY_OPTIMIZED = ON,<br />
     DURABILITY = SCHEMA_AND_DATA<br />
 )<br />
 GO

 -- Create a new system-versioned table<br />
 CREATE TABLE Persons<br />
 (<br />
     ID INT IDENTITY(1, 1) PRIMARY KEY NONCLUSTERED HASH WITH (BUCKET_COUNT = 1024),<br />
     FirstName VARCHAR(100) NOT NULL,<br />
     LastName VARCHAR(100) NOT NULL,<br />
     City VARCHAR(100) NOT NULL,

     -- Needed for System-Versioned Tables<br />
     StartDate DATETIME2 GENERATED ALWAYS AS ROW START NOT NULL,<br />
     EndDate DATETIME2 GENERATED ALWAYS AS ROW END NOT NULL,<br />
     PERIOD FOR SYSTEM_TIME (StartDate, EndDate)<br />
 )<br />
 WITH<br />
 (<br />
     -- Needed for System-Versioned Tables<br />
     SYSTEM_VERSIONING = ON<br />
     (<br />
         -- Name of the history table (optional)<br />
         HISTORY_TABLE = dbo.PersonHistory<br />
     ),<br />
     MEMORY_OPTIMIZED = ON,<br />
     DURABILITY = SCHEMA_AND_DATA<br />
 )<br />
 GO

 -- The current table is a Memory-Optimized Table, the history table<br />
 -- is a traditional Disk-Based Table.<br />
 SELECT is_memory_optimized, * FROM sys.tables<br />
 WHERE object_id IN(OBJECT_ID('Persons'), OBJECT_ID('PersonHistory'))<br />
 GO

 -- Create a parent table<br />
 CREATE TABLE LetsTrySchemaChanges<br />
 (<br />
     ID INT IDENTITY(1, 1) NOT NULL PRIMARY KEY NONCLUSTERED HASH WITH (BUCKET_COUNT = 1024),<br />
     Col1 CHAR(100) NOT NULL,<br />
     Col2 CHAR(100) NOT NULL,<br />
     Col3 CHAR(100) NOT NULL<br />
 )<br />
 WITH (MEMORY_OPTIMIZED = ON)<br />
 GO

 -- Schema Changes are now also supported on Memory-Optimized tables.<br />
 ALTER TABLE LetsTrySchemaChanges ADD Test CHAR(100) NULL<br />
 GO

 -- The creation of an index after the table creation is not supported<br />
 CREATE NONCLUSTERED HASH INDEX idx_Test ON LetsTrySchemaChanges(Col3)<br />
 WITH (BUCKET_COUNT = 1024)<br />
 GO
     </pre>
</div>
<h1>小结</h1>
<p>从这个文章里，你可以看到在SQL Server 2016里，内存OLTP已经彻底翻新了。现在如果有人问我它们是否应该使用内存中OLTP，我会说是的&mdash;&mdash;如要你有对应的问题，而且这些问题使用SQL Server的传统关系引擎不能解决的。</p>
<p>除了我在这篇文章里提到的提升外，SQL Server 2016里的内存OLTP可以给你的其他的提升，我会在接下来的文章里谈到。</p>
<p>对这些提升你有啥想法？请尽情留言。</p>
<h1>参考文章：</h1>
<p><a href="http://www.sqlpassion.at/archive/2015/11/16/why-i-now-eventually-recommend-in-memory-oltp/" rel="external nofollow noreferrer">http://www.sqlpassion.at/archive/2015/11/16/why-i-now-eventually-recommend-in-memory-oltp/</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pd6oz9.html">如何使用android百度地图离线地图</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ozzox9.html">Jquery的初识</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv06jyq.html">C&num;inSSIDer强大的wifi无线热点信号扫描器源码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwde0dr8.html">&lpar;转&rpar;  UIALertView的基本用法与UIAlertViewDelegate对对话框的事件处理方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1medx9.html">Ubuntu10&period;4 install jdk1&period;6</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k73049.html">Python自省</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzowkg8.html">There was a problem with the instance info replicator</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdez2z9.html">python&lpar;7&rpar;&colon;sympy模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gwglmq.html">DOS简单文件指令</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wv47wq.html">重置BizTalk RosettaNet</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwkmv79.html">JavaScript形而上的策略模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv4per8.html">xpath和lxml类库</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvzjjz8.html">Kafka实战－KafkaOffsetMonitor</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvywkr8.html">将 django部署到 heroku上</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r52d44q.html">Android四种布局方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1m1219.html">Linux上软件安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emjzkx9.html">不要用for in语句对数组进行遍历</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlz5jr9.html">Android热点回顾第六期</a>
		</li>
						<li><a href="https://www.batexi.com/a/953yjxv8.html">推荐：这才是你寻寻觅觅想要的 Python 可视化神器</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pm7z279.html">JavaScript各类型变量和对象</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/oqv74jqx.html">AngularJs之八</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rm0480.html">ThinkPhp5&period;0模型验证规则</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gkwz87.html">python &lowbar;&lowbar;globals&lowbar;&lowbar;&comma;  &lowbar;&lowbar;file&lowbar;&lowbar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/r932xrq3.html">Oracle简单常用的数据泵导出导入&lpar;expdp&sol;impdp&rpar;命令举例&lpar;上&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwmjz87.html">OCP考点实战演练02-日常维护篇</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdy5jqd.html">ASP&period;NET Core 中文文档 第二章 指南（4&period;1）ASP&period;NET Core MVC 与 Visual Studio 入门</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlr4eqo.html">php内核分析（三）－全局变量</a>
			</li>
						<li><a href="https://www.batexi.com/a/495o368z.html">&lbrack;占位-未完成&rsqb;scikit-learn一般实例之十二&colon;用于RBF核的显式特征映射逼近</a>
			</li>
						<li><a href="https://www.batexi.com/a/3906239d.html">MahApps&period;Metro使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyz6j9r.html">推荐几篇关于EF的好文章</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
